OGRE: Ogre::D3D9RenderSystem Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::D3D9RenderSystem Class Reference
RenderSystems » Direct3D9

Implementation of DirectX9 as a rendering system. More...

`#include <OgreD3D9RenderSystem.h>`

Inheritance diagram for Ogre::D3D9RenderSystem:
[legend]

## Public Types
enum | MultiheadUseType { mutAuto , mutYes , mutNo }

## Public Member Functions
| D3D9RenderSystem (HINSTANCE hInstance)
| ~D3D9RenderSystem ()
DepthBuffer * | _addManualDepthBuffer (IDirect3DDevice9 *depthSurfaceDevice, IDirect3DSurface9 *surf)
| This function is meant to add Depth Buffers to the pool that aren't released when the DepthBuffer is deleted.
void | _beginFrame ()
| Signifies the beginning of a frame, i.e.
bool | _checkTextureFilteringSupported (TextureType ttype, PixelFormat format, int usage)
| Check whether or not filtering is supported for the precise texture format requested with the given usage options.
void | _cleanupDepthBuffers (bool bCleanManualBuffers=true)
| Removes all depth buffers.
void | _cleanupDepthBuffers (IDirect3DDevice9 *creator)
| This function does NOT override RenderSystem::_cleanupDepthBuffers(bool) functionality.
void | _cleanupDepthBuffers (IDirect3DSurface9 *manualSurface)
| This function does NOT override RenderSystem::_cleanupDepthBuffers(bool) functionality.
void | _convertProjectionMatrix (const Matrix4 &matrix, Matrix4 &dest, bool forGpuProgram=false)
| Converts a uniform projection matrix to suitable for this render system.
DepthBuffer * | _createDepthBufferFor (RenderTarget *renderTarget)
| Creates a DepthBuffer that can be attached to the specified RenderTarget.
RenderWindow * | _createRenderWindow (const String &name, unsigned int width, unsigned int height, bool fullScreen, const NameValuePairList *miscParams=0)
| Creates a new rendering window.
void | _endFrame ()
| Ends rendering of a frame to the current viewport.
D3DFORMAT | _getDepthStencilFormatFor (D3DFORMAT fmt)
| Check which depthStencil formats can be used with a certain pixel format, and return the best suited.
void | _initialise () override
| Start up the renderer using the settings selected (Or the defaults if none have been selected).
void | _render (const RenderOperation &op)
| Render something to the active viewport.
void | _setAlphaRejectSettings (CompareFunction func, unsigned char value, bool alphaToCoverage)
| Sets the global alpha rejection approach for future renders.
void | _setCullingMode (CullingMode mode)
| Sets the culling mode for the render system based on the 'vertex winding'.
void | _setDepthBias (float constantBias, float slopeScaleBias)
| Sets the depth bias, NB you should use the Material version of this.
void | _setDepthBufferCheckEnabled (bool enabled=true)
void | _setDepthBufferFunction (CompareFunction func=CMPF_LESS_EQUAL)
void | _setDepthBufferParams (bool depthTest=true, bool depthWrite=true, CompareFunction depthFunction=CMPF_LESS_EQUAL)
| Sets the mode of operation for depth buffer tests from this point onwards.
void | _setDepthBufferWriteEnabled (bool enabled=true)
void | _setFog (FogMode mode)
void | _setPointParameters (bool attenuationEnabled, Real minSize, Real maxSize)
void | _setPointSpritesEnabled (bool enabled)
| Sets whether or not rendering points using OT_POINT_LIST will render point sprites (textured quads) or plain points.
void | _setPolygonMode (PolygonMode level)
| Sets how to rasterise triangles, as points, wireframe or solid polys.
void | _setRenderTarget (RenderTarget *target)
| Set current render target to target, enabling its GL context if needed.
void | _setSampler (size_t unit, Sampler &sampler)
| set the sampler settings for the given texture unit
void | _setSurfaceTracking (TrackVertexColourType tracking)
void | _setTexture (size_t unit, bool enabled, const TexturePtr &texPtr)
| Sets the texture to bind to a given texture unit.
void | _setTextureBlendMode (size_t unit, const LayerBlendModeEx &bm)
| Sets the texture blend modes from a TextureUnitState record.
void | _setTextureCoordCalculation (size_t unit, TexCoordCalcMethod m, const Frustum *frustum=0)
| Sets a method for automatically calculating texture coordinates for a stage.
void | _setTextureCoordSet (size_t unit, size_t index)
| Sets the texture coordinate set to use for a texture unit.
void | _setTextureMatrix (size_t unit, const Matrix4 &xform)
| Sets the texture coordinate transformation matrix for a texture unit.
void | _setViewport (Viewport *vp)
| Sets the provided viewport as the active one for future rendering operations.
void | _useLights (unsigned short limit)
| Tells the rendersystem to use the attached set of lights (and no others) up to the number specified (this allows the same list to be used with different count limits).
void | applyFixedFunctionParams (const GpuProgramParametersPtr &params, uint16 variabilityMask)
virtual void | beginProfileEvent (const String &eventName)
| This marks the beginning of an event for GPU profiling.
void | bindGpuProgram (GpuProgram *prg)
| Binds a given GpuProgram (but not the parameters).
void | bindGpuProgramParameters (GpuProgramType gptype, const GpuProgramParametersPtr &params, uint16 variabilityMask)
| Bind Gpu program parameters.
void | clearFrameBuffer (unsigned int buffers, const ColourValue &colour=ColourValue::Black, float depth=1.0f, unsigned short stencil=0)
HardwareOcclusionQuery * | createHardwareOcclusionQuery ()
| Create an object for performing hardware occlusion queries.
virtual MultiRenderTarget * | createMultiRenderTarget (const String &name)
| Create a MultiRenderTarget, which is a render target that renders to multiple RenderTextures at once.
void | createStereoDriver (const NameValuePairList *miscParams)
| Creates a bridge to the Direct3D stereo driver implementation.
void | destroyRenderTarget (const String &name)
| Destroys a render target of any sort.
virtual RenderTarget * | detachRenderTarget (const String &name)
| Detaches the render target with the passed name from the render system and returns a pointer to it.
void | determineFSAASettings (IDirect3DDevice9 *d3d9Device, size_t fsaa, const String &fsaaHint, D3DFORMAT d3dPixelFormat, bool fullScreen, D3DMULTISAMPLE_TYPE *outMultisampleType, DWORD *outMultisampleQuality)
| Take in some requested FSAA settings and output supported D3D settings.
void | enableClipPlane (ushort index, bool enable)
virtual void | endProfileEvent (void)
| Ends the currently active GPU profiling event.
void | fireDeviceEvent (D3D9Device *device, const String &name)
| Fires a device related event.
uint32 | getAdapterNumber ()
String | getErrorDescription (long errorNumber) const
const GpuProgramParametersPtr & | getFixedFunctionParams (TrackVertexColourType tracking, FogMode fog)
Real | getHorizontalTexelOffset ()
| Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this rendersystem.
Real | getMaximumDepthInputValue ()
| Gets the maximum (farthest) depth value to be used when rendering using identity transforms.
Real | getMinimumDepthInputValue ()
| Gets the minimum (closest) depth value to be used when rendering using identity transforms.
MultiheadUseType | getMultiheadUse () const
| Returns how multihead should be activated.
const String & | getName () const
| Returns the name of the rendering system.
Real | getVerticalTexelOffset ()
| Returns the vertical texel offset value required for mapping texel origins to pixel origins in this rendersystem.
virtual void | initConfigOptions ()
bool | IsActiveDeviceLost ()
virtual void | markProfileEvent (const String &eventName)
| Marks an instantaneous event for graphics profilers.
void | setAmbientLight (float r, float g, float b)
void | setClipPlane (ushort index, Real A, Real B, Real C, Real D)
void | setColourBlendState (const ColourBlendState &state)
| Sets the global blending factors for combining subsequent renders with the existing frame contents.
void | setConfigOption (const String &name, const String &value)
| Specific options:
virtual bool | setDrawBuffer (ColourBufferType colourBuffer)
| Sets the colour buffer that the render system will to draw.
void | setLightingEnabled (bool enabled)
| Sets whether or not dynamic lighting is enabled.
void | setNormaliseNormals (bool normalise)
| Sets whether or not normals are to be automatically normalised.
void | setScissorTest (bool enabled, const Rect &rect=Rect())
| Sets the 'scissor region' i.e.
void | setShadingType (ShadeOptions so)
| Sets the type of light shading required (default = Gouraud).
void | setStencilState (const StencilState &state) override
| This method allows you to set all the stencil buffer parameters in one call.
void | setVertexBufferBinding (VertexBufferBinding *binding, int numberOfInstances, bool indexesUsed)
void | setVertexDeclaration (VertexDeclaration *decl)
void | shutdown ()
| Shutdown the renderer and cleanup resources.
void | unbindGpuProgram (GpuProgramType gptype)
| Unbinds GpuPrograms of a given GpuProgramType.
String | validateConfigOptions ()
| Validates the options set for the rendering system, returning a message if there are problems.
Public Member Functions inherited from Ogre::RenderSystem
| RenderSystem ()
| Default Constructor.
virtual | ~RenderSystem ()
| Destructor.
void | _beginGeometryCount (void)
| The RenderSystem will keep a count of tris rendered, this resets the count.
void | _cleanupDepthBuffers (bool bCleanManualBuffers=true)
| Removes all depth buffers.
virtual void | _disableTextureUnit (size_t texUnit)
| Turns off a texture unit.
virtual void | _disableTextureUnitsFrom (size_t texUnit)
| Disables all texture units from the given unit upwards.
virtual void | _dispatchCompute (const Vector3i &workgroupDim)
unsigned int | _getBatchCount (void) const
| Reports the number of batches rendered since the last _beginGeometryCount call.
virtual CullingMode | _getCullingMode (void) const
const String & | _getDefaultViewportMaterialScheme (void) const
| Returns the default material scheme used by the render system.
unsigned int | _getFaceCount (void) const
| Reports the number of tris rendered since the last _beginGeometryCount call.
unsigned int | _getVertexCount (void) const
| Reports the number of vertices passed to the renderer since the last _beginGeometryCount call.
virtual Viewport * | _getViewport (void)
| Get the current active viewport for rendering.
void | _initRenderTargets (void)
| Utility method for initialising all render targets attached to this rendering system.
void | _notifyCameraRemoved (const Camera *cam)
| Utility method to notify all render targets that a camera has been removed, in case they were referring to it as their viewer.
void | _setColourBufferWriteEnabled (bool red, bool green, bool blue, bool alpha)
virtual void | _setDepthClamp (bool enable)
| Clamp depth values to near and far plane rather than discarding.
void | _setFog (FogMode f)
virtual void | _setLineWidth (float width)
| Set the line width when drawing as RenderOperation::OT_LINE_LIST/ RenderOperation::OT_LINE_STRIP.
void | _setProjectionMatrix (Matrix4 m)
void | _setSceneBlending (SceneBlendFactor sourceFactor, SceneBlendFactor destFactor, SceneBlendOperation op=SBO_ADD)
void | _setSeparateSceneBlending (SceneBlendFactor sourceFactor, SceneBlendFactor destFactor, SceneBlendFactor sourceFactorAlpha, SceneBlendFactor destFactorAlpha, SceneBlendOperation op=SBO_ADD, SceneBlendOperation alphaOp=SBO_ADD)
virtual void | _setTextureProjectionRelativeTo (bool enabled, const Vector3 &pos)
| Notify the rendersystem that it should adjust texture projection to be relative to a different origin.
virtual void | _setTextureUnitSettings (size_t texUnit, TextureUnitState &tl)
| Utility function for setting all the properties of a texture unit at once.
void | _setViewMatrix (const Matrix4 &m)
void | _setWorldMatrix (const Matrix4 &m)
virtual void | _swapAllRenderTargetBuffers ()
| Internal method for swapping all the buffers on all render targets, if _updateAllRenderTargets was called with a 'false' parameter.
virtual void | _updateAllRenderTargets (bool swapBuffers=true)
| Internal method for updating all render targets attached to this rendering system.
void | addListener (Listener *l)
| Adds a listener to the custom events that this render system can raise.
void | attachRenderTarget (RenderTarget &target)
| Attaches the passed render target to the render system.
virtual void | clearFrameBuffer (uint32 buffers, const ColourValue &colour=ColourValue::Black, float depth=1.0f, uint16 stencil=0)=0
| Clears one or more frame buffers on the active render target.
virtual void | destroyHardwareOcclusionQuery (HardwareOcclusionQuery *hq)
| Destroy a hardware occlusion query object.
virtual void | destroyRenderTexture (const String &name)
| Destroys a render texture.
virtual void | destroyRenderWindow (const String &name)
| Destroys a render window.
void | disableSchemeInstancing (const String &materialScheme)
| disables instancing for the given material scheme
void | enableSchemeInstancing (const String &materialScheme, const HardwareVertexBufferPtr &buffer, VertexDeclaration *decl, uint32 instanceCount)
| Sets the global instance data for the given material scheme.
const RenderSystemCapabilities * | getCapabilities (void) const
| Gets the capabilities of the render system.
const ConfigOptionMap & | getConfigOptions () const
| Returns the details of this API's configuration options.
virtual void | getCustomAttribute (const String &name, void *pData)
| Gets a custom (maybe platform-specific) attribute.
const DriverVersion & | getDriverVersion (void) const
| Returns the driver version.
uint32 | getGlobalInstanceCount () const
HardwareVertexBufferPtr | getGlobalInstanceVertexBuffer () const
VertexDeclaration * | getGlobalInstanceVertexDeclaration () const
bool | getInvertVertexWinding (void) const
| Indicates whether or not the vertex windings set will be inverted for the current render (e.g.
RenderSystemCapabilities * | getMutableCapabilities ()
| Get a pointer to the current capabilities being used by the RenderSystem.
uint16 | getNativeShadingLanguageVersion () const
| Gets the native shading language version for this render system.
const StringVector & | getRenderSystemEvents (void) const
| Gets a list of the rendersystem specific events that this rendersystem can raise.
RenderTarget * | getRenderTarget (const String &name)
| Returns a pointer to the render target with the passed name, or NULL if that render target cannot be found.
RenderWindowDescription | getRenderWindowDescription () const
| get a RenderWindowDescription from the current ConfigOptionMap
GlobalInstancingData | getSchemeInstancingData (const String &materialScheme) const
| Gets all data for the global scheme based instancing.
bool | isGpuProgramBound (GpuProgramType gptype)
| Returns whether or not a Gpu program of the given type is currently bound.
bool | isReverseDepthBufferEnabled () const
| Returns if reverse Z-buffer is enabled.
virtual void | postExtraThreadsStarted ()
| Tell the rendersystem to perform any tasks it needs to directly after other threads which might access the rendering API are registered.
virtual void | preExtraThreadsStarted ()
| Tell the rendersystem to perform any prep tasks it needs to directly before other threads which might access the rendering API are registered.
virtual void | registerThread ()
| Register the an additional thread which may make calls to rendersystem-related objects.
void | reinitialise (void)
| Restart the renderer (normally following a change in settings).
void | removeListener (Listener *l)
| Remove a listener to the custom events that this render system can raise.
virtual void | setClipPlanes (const PlaneList &clipPlanes)
| Sets the user clipping region.
virtual void | setCurrentPassIterationCount (const size_t count)
| set the current multi pass count value.
void | setDepthBufferFor (RenderTarget *renderTarget)
| Retrieves an existing DepthBuffer or creates a new one suited for the given RenderTarget and sets it.
void | setDeriveDepthBias (bool derive, float baseValue=0.0f, float multiplier=0.0f, float slopeScale=0.0f)
| Tell the render system whether to derive a depth bias on its own based on the values passed to it in setCurrentPassIterationCount.
void | setGlobalInstanceCount (uint32 val)
void | setGlobalInstanceVertexBuffer (const HardwareVertexBufferPtr &val)
void | setGlobalInstanceVertexDeclaration (VertexDeclaration *val)
void | setInvertVertexWinding (bool invert)
| Sets whether or not vertex windings set should be inverted; this can be important for rendering reflections.
void | setScissorTest (bool enabled, uint32 left, uint32 top=0, uint32 right=800, uint32 bottom=600)
void | setStencilBufferParams (CompareFunction func=CMPF_ALWAYS_PASS, uint32 refValue=0, uint32 compareMask=0xFFFFFFFF, uint32 writeMask=0xFFFFFFFF, StencilOperation stencilFailOp=SOP_KEEP, StencilOperation depthFailOp=SOP_KEEP, StencilOperation passOp=SOP_KEEP, bool twoSidedOperation=false)
void | setStencilCheckEnabled (bool enabled)
virtual void | unregisterThread ()
| Unregister an additional thread which may make calls to rendersystem-related objects.
void | useCustomRenderSystemCapabilities (RenderSystemCapabilities *capabilities)
| Force the render system to use the special capabilities.

## Static Public Member Functions
static IDirect3DDevice9 * | getActiveD3D9Device ()
static IDirect3DDevice9 * | getActiveD3D9DeviceIfExists ()
static D3D9DeviceManager * | getDeviceManager ()
static IDirect3D9 * | getDirect3D9 ()
static IDirect3DDevice9 * | getResourceCreationDevice (UINT index)
static UINT | getResourceCreationDeviceCount ()
static D3D9ResourceManager * | getResourceManager ()
static bool | isDirectX9Ex ()
| Tells whether the system is initialized with DirectX 9Ex driver Read more in http://msdn.microsoft.com/en-us/library/windows/desktop/ee890072(v=vs.85).aspx.
Static Public Member Functions inherited from Ogre::RenderSystem
static void | convertColourValue (const ColourValue &colour, uint32 *pDest)
static VertexElementType | getColourVertexElementType (void)
static Listener * | getSharedListener (void)
| Retrieve a pointer to the current shared render system listener.
static void | setSharedListener (Listener *listener)
| Sets shared listener.

## Detailed Description

Implementation of DirectX9 as a rendering system.

## Member Enumeration Documentation

## ◆ MultiheadUseType

enum Ogre::D3D9RenderSystem::MultiheadUseType

Enumerator
mutAuto |
mutYes |
mutNo |

## Constructor & Destructor Documentation

## ◆ D3D9RenderSystem()

Ogre::D3D9RenderSystem::D3D9RenderSystem | ( | HINSTANCE | hInstance | ) |

## ◆ ~D3D9RenderSystem()

Ogre::D3D9RenderSystem::~D3D9RenderSystem | ( |  | ) |

## Member Function Documentation

## ◆ initConfigOptions()

virtual void Ogre::D3D9RenderSystem::initConfigOptions | ( |  | ) |
| virtual

Reimplemented from Ogre::RenderSystem.

## ◆ getFixedFunctionParams()

const GpuProgramParametersPtr & Ogre::D3D9RenderSystem::getFixedFunctionParams | ( | TrackVertexColourType | tracking,
|  | FogMode | fog )
| virtual

Reimplemented from Ogre::RenderSystem.

## ◆ applyFixedFunctionParams()

void Ogre::D3D9RenderSystem::applyFixedFunctionParams | ( | const GpuProgramParametersPtr & | params,
|  | uint16 | variabilityMask )
| virtual

Reimplemented from Ogre::RenderSystem.

## ◆ validateConfigOptions()

String Ogre::D3D9RenderSystem::validateConfigOptions | ( | void |  | ) |
| virtual

Validates the options set for the rendering system, returning a message if there are problems.

Note
  If the returned string is empty, there are no problems.

Reimplemented from Ogre::RenderSystem.

## ◆ _initialise()

void Ogre::D3D9RenderSystem::_initialise | ( |  | ) |
| overridevirtual

Start up the renderer using the settings selected (Or the defaults if none have been selected).

Called by Root::setRenderSystem. Shouldn't really be called directly, although this can be done if the app wants to.

Reimplemented from Ogre::RenderSystem.

## ◆ _createRenderWindow()

RenderWindow * Ogre::D3D9RenderSystem::_createRenderWindow | ( | const String & | name,
|  | unsigned int | width,
|  | unsigned int | height,
|  | bool | fullScreen,
|  | const NameValuePairList * | miscParams = 0 )
| virtual

Creates a new rendering window.

This method creates a new rendering window as specified by the paramteters. The rendering system could be responible for only a single window (e.g. in the case of a game), or could be in charge of multiple ones (in the case of a level editor). The option to create the window as a child of another is therefore given. This method will create an appropriate subclass of RenderWindow depending on the API and platform implementation.

  After creation, this window can be retrieved using getRenderTarget().

Parameters

  name | The name of the window. Used in other methods later like setRenderTarget and getRenderTarget.
  width | The width of the new window.
  height | The height of the new window.
  fullScreen | Specify true to make the window full screen without borders, title bar or menu bar.
  miscParams | A NameValuePairList describing the other parameters for the new rendering window. Options are case sensitive. Unrecognised parameters will be ignored silently. These values might be platform dependent, but these are present for all platforms unless indicated otherwise:

Key | Type / Values | Default | Description | Platform
--- | --- | --- | --- | ---
title | String | RenderTarget name | The title of the window that will appear in the title bar |
left | Positive integers | Centred | Screen x coordinate from left |
top | Positive integers | Centred | Screen y coordinate from left |
hidden | true, false | false | hide the created window |
FSAA | Positive integer (usually 0, 2, 4, 8, 16) | 0 | Full screen antialiasing factor |
gamma | true, false | false | Enable hardware conversion from linear colour space to gamma colour space on rendering to the window. |
vsync | true, false | false | Synchronize buffer swaps to monitor vsync, eliminating tearing at the expense of a fixed frame rate |
vsyncInterval | 1, 2, 3, 4 | 1 | If vsync is enabled, the minimum number of vertical blanks that should occur between renders. For example if vsync is enabled, the refresh rate is 60 and this is set to 2, then the frame rate will be locked at 30. |
Full Screen | true, false | false | Specify whether to create the window in full screen mode |
border | none, fixed, resize | resize | The type of window border (in windowed mode) | Windows, OSX
displayFrequency | Refresh rate in Hertz (e.g. 60, 75, 100) | Desktop vsync rate | Display frequency rate, for fullscreen mode |
externalWindowHandle | Win32: HWND as int Linux: X11 Window as ulong OSX: OgreGLView address as an integer. You can pass NSView or NSWindow too, but should perform OgreGLView callbacks into the Ogre manually iOS: UIWindow address as an integer Emscripten: canvas selector String ("#canvas") | 0 (none) | External window handle, for embedding the OGRE render in an existing window |
externalGLControl | true, false | false | Let the external window control OpenGL i.e. don't select a pixel format for the window, do not change v-sync and do not swap buffer. When set to true, the calling application is responsible of OpenGL initialization and buffer swapping. It should also create an OpenGL context for its own rendering, Ogre will create one for its use. Then the calling application must also enable Ogre OpenGL context before calling any Ogre function and restore its OpenGL context after these calls. | OpenGL
externalWlDisplay | wl_display address as an integer | 0 (none) | Wayland display connection | Linux
externalWlSurface | wl_surface address as an integer | 0 (none) | Wayland onscreen surface | Linux
currentGLContext | true, false | false | Use an externally created GL context. (Must be current) | OpenGL
currentEGLSurface | true, false | false | Use an externally created EGL surface. | Android
minColourBufferSize | Positive integer (usually 16, 32) | 16 | Min total colour buffer size. See EGL_BUFFER_SIZE | OpenGL
windowProc | WNDPROC | DefWindowProc | function that processes window messages | Win 32
colourDepth | 16, 32 | Desktop depth | Colour depth of the resulting rendering window; only applies if fullScreen | Win32
FSAAHint | RenderSystem specific. Currently enables EQAA/ CSAA mode on D3D: if you want 4f8x (8x CSAA), set FSAA=4 and this to "f8" | Blank | FSAA mode hint | D3D
outerDimensions | true, false | false | Whether the width/height is expressed as the size of the outer window, rather than the content area | Win32
monitorIndex |  | -1 |  | Win 32
monitorHandle |  | 0 (none) |  | Win 32 (OpenGL)
enableDoubleClick | true, false | false | Enable the window to keep track and transmit double click messages. | Win32
useNVPerfHUD | true, false | false | Enable the use of nVidia NVPerfHUD | D3D
depthBuffer | true, false | true | Use depth buffer | D3D
NSOpenGLCPSurfaceOrder | -1 or 1 | 1 | NSOpenGLCPSurfaceOrder | OSX
contentScalingFactor | Positive Float | The default content scaling factor of the screen | On IOS specifies the CAEAGLLayer content scaling factor. This can be useful to limit the resolution of the OpenGL ES backing store. For example, the iPhone 4's native resolution is 960 x 640. Windows are always 320 x 480, if you would like to limit the display to 720 x 480, specify 1.5 as the scaling factor. | OSX, iOS, Android
externalViewHandle | UIView pointer as an integer | 0 | External view handle, for rendering OGRE render in an existing view | iOS
externalViewControllerHandle | UIViewController pointer as an integer | 0 | External view controller handle, for embedding OGRE in an existing view controller | iOS
externalSharegroup | EAGLSharegroup pointer as an integer | 0 | External sharegroup, used to shared GL resources between contexts | iOS
CSAA | Positive integer (usually 0, 2, 4, 8, 16) | 0 | Coverage sampling factor | Android
maxColourBufferSize | Positive integer (usually 16, 32) | 32 | Max EGL_BUFFER_SIZE | Android
maxStencilBufferSize | Positive integer (usually 0, 8) | 0 | EGL_STENCIL_SIZE | Android
maxDepthBufferSize | Positive integer (usually 0, 16, 24) | 16 | EGL_DEPTH_SIZE | Android

Reimplemented from Ogre::RenderSystem.

## ◆ _createDepthBufferFor()

DepthBuffer * Ogre::D3D9RenderSystem::_createDepthBufferFor | ( | RenderTarget * | renderTarget | ) |
| virtual

Creates a DepthBuffer that can be attached to the specified RenderTarget.

It doesn't attach anything, it just returns a pointer to a new DepthBuffer Caller is responsible for putting this buffer into the right pool, for attaching, and deleting it. Here's where API-specific magic happens. Don't call this directly unless you know what you're doing.

Implements Ogre::RenderSystem.

## ◆ _addManualDepthBuffer()

DepthBuffer * Ogre::D3D9RenderSystem::_addManualDepthBuffer | ( | IDirect3DDevice9 * | depthSurfaceDevice,
|  | IDirect3DSurface9 * | surf )

This function is meant to add Depth Buffers to the pool that aren't released when the DepthBuffer is deleted.

This is specially useful to put the Depth Buffer created along with the window's back buffer into the pool. All depth buffers introduced with this method go to POOL_DEFAULT

References Ogre::RenderSystem::_cleanupDepthBuffers().

## ◆ _cleanupDepthBuffers() [1/3]

void Ogre::D3D9RenderSystem::_cleanupDepthBuffers | ( | IDirect3DDevice9 * | creator | ) |

This function does NOT override RenderSystem::_cleanupDepthBuffers(bool) functionality.

On multi monitor setups, when a device becomes "inactive" (it has no RenderWindows; like when the window was moved from one monitor to another); the Device will be destroyed, meaning all it's depth buffers (auto & manual) should be removed from the pool, but only selectively removing those created by that D3D9Device.

Parameters

  creator | device to compare against. Shouldn't be null

## ◆ _cleanupDepthBuffers() [2/3]

void Ogre::D3D9RenderSystem::_cleanupDepthBuffers | ( | IDirect3DSurface9 * | manualSurface | ) |

This function does NOT override RenderSystem::_cleanupDepthBuffers(bool) functionality.

Manually created surfaces may be released arbitrarely without being pulled out from the pool (specially RenderWindows) this function takes care of that.

Parameters

  manualSurface | Depth buffer surface to compare against. Shouldn't be null

## ◆ _setRenderTarget()

void Ogre::D3D9RenderSystem::_setRenderTarget | ( | RenderTarget * | target | ) |
| virtual

Set current render target to target, enabling its GL context if needed.

Implements Ogre::RenderSystem.

## ◆ createMultiRenderTarget()

virtual MultiRenderTarget * Ogre::D3D9RenderSystem::createMultiRenderTarget | ( | const String & | name | ) |
| virtual

Create a MultiRenderTarget, which is a render target that renders to multiple RenderTextures at once.

Surfaces can be bound and unbound at will. This fails if mCapabilities->getNumMultiRenderTargets() is smaller than 2.

Implements Ogre::RenderSystem.

## ◆ detachRenderTarget()

virtual RenderTarget * Ogre::D3D9RenderSystem::detachRenderTarget | ( | const String & | name | ) |
| virtual

Detaches the render target with the passed name from the render system and returns a pointer to it.

Note
  If the render target cannot be found, NULL is returned.

Reimplemented from Ogre::RenderSystem.

## ◆ getErrorDescription()

String Ogre::D3D9RenderSystem::getErrorDescription | ( | long | errorNumber | ) | const

## ◆ getName()

const String & Ogre::D3D9RenderSystem::getName | ( |  | ) | const
| virtual

Returns the name of the rendering system.

Implements Ogre::RenderSystem.

## ◆ setConfigOption()

void Ogre::D3D9RenderSystem::setConfigOption | ( | const String & | name,
|  | const String & | value )
| virtual

Specific options:

Key | Default | Description
--- | --- | ---
Allow DirectX9Ex | No | Use Direct3D 9Ex if possible
Multi device memory hint | Auto hardware buffers management | Automatically restore hardware buffers on device lost
Resource Creation Policy | - | See D3D9ResourceCreationPolicy
Fixed Pipeline Enabled | true | Use fixed function units where possible. Disable to test migration to shader-only pipeline
Rendering Device | (default) |

Implements Ogre::RenderSystem.

## ◆ shutdown()

void Ogre::D3D9RenderSystem::shutdown | ( |  | ) |
| virtual

Shutdown the renderer and cleanup resources.

Reimplemented from Ogre::RenderSystem.

## ◆ setAmbientLight()

void Ogre::D3D9RenderSystem::setAmbientLight | ( | float | r,
|  | float | g,
|  | float | b )

## ◆ setShadingType()

void Ogre::D3D9RenderSystem::setShadingType | ( | ShadeOptions | so | ) |
| virtual

Sets the type of light shading required (default = Gouraud).

Deprecated
  only needed for fixed function APIs

Reimplemented from Ogre::RenderSystem.

## ◆ setLightingEnabled()

void Ogre::D3D9RenderSystem::setLightingEnabled | ( | bool | enabled | ) |
| virtual

Sets whether or not dynamic lighting is enabled.

Parameters

  enabled | If true, dynamic lighting is performed on geometry with normals supplied, geometry without normals will not be displayed. If false, no lighting is applied and all geometry will be full brightness.

Deprecated
  only needed for fixed function APIs

Reimplemented from Ogre::RenderSystem.

## ◆ destroyRenderTarget()

void Ogre::D3D9RenderSystem::destroyRenderTarget | ( | const String & | name | ) |
| virtual

Destroys a render target of any sort.

Reimplemented from Ogre::RenderSystem.

## ◆ setStencilState()

void Ogre::D3D9RenderSystem::setStencilState | ( | const StencilState & | state | ) |
| overridevirtual

This method allows you to set all the stencil buffer parameters in one call.

Unlike other render states, stencilling is left for the application to turn on and off when it requires. This is because you are likely to want to change parameters between batches of arbitrary objects and control the ordering yourself. In order to batch things this way, you'll want to use OGRE's Compositor stencil pass or separate render queue groups and register a RenderQueueListener to get notifications between batches.

See also
  RenderQueue

Implements Ogre::RenderSystem.

## ◆ setNormaliseNormals()

void Ogre::D3D9RenderSystem::setNormaliseNormals | ( | bool | normalise | ) |
| virtual

Sets whether or not normals are to be automatically normalised.

This is useful when, for example, you are scaling SceneNodes such that normals may not be unit-length anymore. Note though that this has an overhead so should not be turn on unless you really need it.

  You should not normally call this direct unless you are rendering world geometry; set it on the Renderable because otherwise it will be overridden by material settings.

Deprecated
  only needed for fixed function APIs

Reimplemented from Ogre::RenderSystem.

## ◆ _useLights()

void Ogre::D3D9RenderSystem::_useLights | ( | unsigned short | limit | ) |
| virtual

Tells the rendersystem to use the attached set of lights (and no others) up to the number specified (this allows the same list to be used with different count limits).

Deprecated
  only needed for fixed function APIs

Reimplemented from Ogre::RenderSystem.

## ◆ _setSurfaceTracking()

void Ogre::D3D9RenderSystem::_setSurfaceTracking | ( | TrackVertexColourType | tracking | ) |

## ◆ _setPointSpritesEnabled()

void Ogre::D3D9RenderSystem::_setPointSpritesEnabled | ( | bool | enabled | ) |
| virtual

Sets whether or not rendering points using OT_POINT_LIST will render point sprites (textured quads) or plain points.

Parameters

  enabled | True enables point sprites, false returns to normal point rendering.

Deprecated
  only needed for fixed function APIs

Reimplemented from Ogre::RenderSystem.

## ◆ _setPointParameters()

void Ogre::D3D9RenderSystem::_setPointParameters | ( | bool | attenuationEnabled,
|  | Real | minSize,
|  | Real | maxSize )
| virtual

Deprecated
  only needed for fixed function APIs

Reimplemented from Ogre::RenderSystem.

## ◆ _setTexture()

void Ogre::D3D9RenderSystem::_setTexture | ( | size_t | unit,
|  | bool | enabled,
|  | const TexturePtr & | texPtr )
| virtual

Sets the texture to bind to a given texture unit.

User processes would not normally call this direct unless rendering primitives themselves.

Parameters

  unit | The index of the texture unit to modify. Multitexturing hardware can support multiple units (see RenderSystemCapabilites::getNumTextureUnits)
  enabled | Boolean to turn the unit on/off
  texPtr | Pointer to the texture to use.

Implements Ogre::RenderSystem.

## ◆ _setSampler()

void Ogre::D3D9RenderSystem::_setSampler | ( | size_t | texUnit,
|  | Sampler & | s )
| virtual

set the sampler settings for the given texture unit

Implements Ogre::RenderSystem.

## ◆ _setTextureCoordSet()

void Ogre::D3D9RenderSystem::_setTextureCoordSet | ( | size_t | unit,
|  | size_t | index )
| virtual

Sets the texture coordinate set to use for a texture unit.

Meant for use internally - not generally used directly by apps - the Material and TextureUnitState classes let you manage textures far more easily.

Parameters

  unit | Texture unit as above
  index | The index of the texture coordinate set to use.

Deprecated
  only needed for fixed function APIs

Reimplemented from Ogre::RenderSystem.

## ◆ _setTextureCoordCalculation()

void Ogre::D3D9RenderSystem::_setTextureCoordCalculation | ( | size_t | unit,
|  | TexCoordCalcMethod | m,
|  | const Frustum * | frustum = 0 )
| virtual

Sets a method for automatically calculating texture coordinates for a stage.

Should not be used by apps - for use by Ogre only.

Parameters

  unit | Texture unit as above
  m | Calculation method to use
  frustum | Optional Frustum param, only used for projective effects

Deprecated
  only needed for fixed function APIs

Reimplemented from Ogre::RenderSystem.

## ◆ _setTextureBlendMode()

void Ogre::D3D9RenderSystem::_setTextureBlendMode | ( | size_t | unit,
|  | const LayerBlendModeEx & | bm )
| virtual

Sets the texture blend modes from a TextureUnitState record.

Meant for use internally only - apps should use the Material and TextureUnitState classes.

Parameters

  unit | Texture unit as above
  bm | Details of the blending mode

Deprecated
  only needed for fixed function APIs

Reimplemented from Ogre::RenderSystem.

## ◆ _setTextureMatrix()

void Ogre::D3D9RenderSystem::_setTextureMatrix | ( | size_t | unit,
|  | const Matrix4 & | xform )
| virtual

Sets the texture coordinate transformation matrix for a texture unit.

Parameters

  unit | Texture unit to affect
  xform | The 4x4 matrix

Deprecated
  only needed for fixed function APIs

Reimplemented from Ogre::RenderSystem.

## ◆ _setAlphaRejectSettings()

void Ogre::D3D9RenderSystem::_setAlphaRejectSettings | ( | CompareFunction | func,
|  | unsigned char | value,
|  | bool | alphaToCoverage )
| virtual

Sets the global alpha rejection approach for future renders.

By default images are rendered regardless of texture alpha. This method lets you change that.

Parameters

  func | The comparison function which must pass for a pixel to be written.
  value | The value to compare each pixels alpha value to (0-255)
  alphaToCoverage | Whether to enable alpha to coverage, if supported

Implements Ogre::RenderSystem.

## ◆ _setViewport()

void Ogre::D3D9RenderSystem::_setViewport | ( | Viewport * | vp | ) |
| virtual

Sets the provided viewport as the active one for future rendering operations.

This viewport is aware of it's own camera and render target. Must be implemented by subclass.

Parameters

  vp | Pointer to the appropriate viewport.

Implements Ogre::RenderSystem.

## ◆ _beginFrame()

void Ogre::D3D9RenderSystem::_beginFrame | ( |  | ) |
| virtual

Signifies the beginning of a frame, i.e.

the start of rendering on a single viewport. Will occur several times per complete frame if multiple viewports exist.

Reimplemented from Ogre::RenderSystem.

## ◆ _endFrame()

void Ogre::D3D9RenderSystem::_endFrame | ( |  | ) |
| virtual

Ends rendering of a frame to the current viewport.

Implements Ogre::RenderSystem.

## ◆ _setCullingMode()

void Ogre::D3D9RenderSystem::_setCullingMode | ( | CullingMode | mode | ) |
| virtual

Sets the culling mode for the render system based on the 'vertex winding'.

A typical way for the rendering engine to cull triangles is based on the 'vertex winding' of triangles. Vertex winding refers to the direction in which the vertices are passed or indexed to in the rendering operation as viewed from the camera, and will either be clockwise or anticlockwise (that's 'counterclockwise' for you Americans out there ;) The default is Ogre::CULL_CLOCKWISE i.e. that only triangles whose vertices are passed/indexed in anticlockwise order are rendered - this is a common approach and is used in 3D studio models for example. You can alter this culling mode if you wish but it is not advised unless you know what you are doing.

You may wish to use the Ogre::CULL_NONE option for mesh data that you cull yourself where the vertex winding is uncertain or for creating 2-sided passes.

Implements Ogre::RenderSystem.

## ◆ _setDepthBufferParams()

void Ogre::D3D9RenderSystem::_setDepthBufferParams | ( | bool | depthTest = true,
|  | bool | depthWrite = true,
|  | CompareFunction | depthFunction = CMPF_LESS_EQUAL )
| virtual

Sets the mode of operation for depth buffer tests from this point onwards.

Sometimes you may wish to alter the behaviour of the depth buffer to achieve special effects. Because it's unlikely that you'll set these options for an entire frame, but rather use them to tweak settings between rendering objects, this is an internal method (indicated by the '_' prefix) which will be used by a SceneManager implementation rather than directly from the client application. If this method is never called the settings are automatically the same as the default parameters.

Parameters

  depthTest | If true, the depth buffer is tested for each pixel and the frame buffer is only updated if the depth function test succeeds. If false, no test is performed and pixels are always written.
  depthWrite | If true, the depth buffer is updated with the depth of the new pixel if the depth test succeeds. If false, the depth buffer is left unchanged even if a new pixel is written.
  depthFunction | Sets the function required for the depth test.

Implements Ogre::RenderSystem.

References Ogre::CMPF_LESS_EQUAL.

## ◆ _setDepthBufferCheckEnabled()

void Ogre::D3D9RenderSystem::_setDepthBufferCheckEnabled | ( | bool | enabled = true | ) |

## ◆ setColourBlendState()

void Ogre::D3D9RenderSystem::setColourBlendState | ( | const ColourBlendState & | state | ) |
| virtual

Sets the global blending factors for combining subsequent renders with the existing frame contents.

Implements Ogre::RenderSystem.

## ◆ _setDepthBufferWriteEnabled()

void Ogre::D3D9RenderSystem::_setDepthBufferWriteEnabled | ( | bool | enabled = true | ) |

## ◆ _setDepthBufferFunction()

void Ogre::D3D9RenderSystem::_setDepthBufferFunction | ( | CompareFunction | func = CMPF_LESS_EQUAL | ) |

References Ogre::CMPF_LESS_EQUAL.

## ◆ _setDepthBias()

void Ogre::D3D9RenderSystem::_setDepthBias | ( | float | constantBias,
|  | float | slopeScaleBias )
| virtual

Sets the depth bias, NB you should use the Material version of this.

When polygons are coplanar, you can get problems with 'depth fighting' where the pixels from the two polys compete for the same screen pixel. This is particularly a problem for decals (polys attached to another surface to represent details such as bulletholes etc.).

  A way to combat this problem is to use a depth bias to adjust the depth buffer value used for the decal such that it is slightly higher than the true value, ensuring that the decal appears on top.

Note
  The final bias value is a combination of a constant bias and a bias proportional to the maximum depth slope of the polygon being rendered. The final bias is constantBias + slopeScaleBias * maxslope. Slope scale biasing is generally preferable but is not available on older hardware.

Parameters

  constantBias | The constant bias value, expressed as a value in homogeneous depth coordinates.
  slopeScaleBias | The bias value which is factored by the maximum slope of the polygon, see the description above. This is not supported by all cards.

Implements Ogre::RenderSystem.

## ◆ _setFog()

void Ogre::D3D9RenderSystem::_setFog | ( | FogMode | mode | ) |

## ◆ _convertProjectionMatrix()

void Ogre::D3D9RenderSystem::_convertProjectionMatrix | ( | const Matrix4 & | matrix,
|  | Matrix4 & | dest,
|  | bool | forGpuProgram = false )
| virtual

Converts a uniform projection matrix to suitable for this render system.

Because different APIs have different requirements (some incompatible) for the projection matrix, this method allows each to implement their own correctly and pass back a generic OGRE matrix for storage in the engine.

Implements Ogre::RenderSystem.

## ◆ _setPolygonMode()

void Ogre::D3D9RenderSystem::_setPolygonMode | ( | PolygonMode | level | ) |
| virtual

Sets how to rasterise triangles, as points, wireframe or solid polys.

Implements Ogre::RenderSystem.

## ◆ setVertexDeclaration()

void Ogre::D3D9RenderSystem::setVertexDeclaration | ( | VertexDeclaration * | decl | ) |

## ◆ setVertexBufferBinding()

void Ogre::D3D9RenderSystem::setVertexBufferBinding | ( | VertexBufferBinding * | binding,
|  | int | numberOfInstances,
|  | bool | indexesUsed )

## ◆ _render()

void Ogre::D3D9RenderSystem::_render | ( | const RenderOperation & | op | ) |
| virtual

Render something to the active viewport.

Low-level rendering interface to perform rendering operations. Unlikely to be used directly by client applications, since the SceneManager and various support classes will be responsible for calling this method. Can only be called between _beginScene and _endScene

Parameters

  op | A rendering operation instance, which contains details of the operation to be performed.

Reimplemented from Ogre::RenderSystem.

## ◆ bindGpuProgram()

void Ogre::D3D9RenderSystem::bindGpuProgram | ( | GpuProgram * | prg | ) |
| virtual

Binds a given GpuProgram (but not the parameters).

Remarks
  Only one GpuProgram of each type can be bound at once, binding another one will simply replace the existing one.

Reimplemented from Ogre::RenderSystem.

## ◆ unbindGpuProgram()

void Ogre::D3D9RenderSystem::unbindGpuProgram | ( | GpuProgramType | gptype | ) |
| virtual

Unbinds GpuPrograms of a given GpuProgramType.

This returns the pipeline to fixed-function processing for this type.

Reimplemented from Ogre::RenderSystem.

## ◆ bindGpuProgramParameters()

void Ogre::D3D9RenderSystem::bindGpuProgramParameters | ( | GpuProgramType | gptype,
|  | const GpuProgramParametersPtr & | params,
|  | uint16 | variabilityMask )
| virtual

Bind Gpu program parameters.

Parameters

  gptype | The type of program to bind the parameters to
  params | The parameters to bind
  variabilityMask | A mask of GpuParamVariability identifying which params need binding

Implements Ogre::RenderSystem.

## ◆ setScissorTest()

void Ogre::D3D9RenderSystem::setScissorTest | ( | bool | enabled,
|  | const Rect & | rect = Rect() )
| virtual

Sets the 'scissor region' i.e.

the region of the target in which rendering can take place.

This method allows you to 'mask off' rendering in all but a given rectangular area as identified by the parameters to this method.

Parameters

  enabled | True to enable the scissor test, false to disable it.
  rect | The location of the corners of the rectangle, expressed in pixels.

Implements Ogre::RenderSystem.

## ◆ clearFrameBuffer()

void Ogre::D3D9RenderSystem::clearFrameBuffer | ( | unsigned int | buffers,
|  | const ColourValue & | colour = ColourValue::Black,
|  | float | depth = 1.0f,
|  | unsigned short | stencil = 0 )

References Ogre::ColourValue::Black.

## ◆ setClipPlane()

void Ogre::D3D9RenderSystem::setClipPlane | ( | ushort | index,
|  | Real | A,
|  | Real | B,
|  | Real | C,
|  | Real | D )

## ◆ enableClipPlane()

void Ogre::D3D9RenderSystem::enableClipPlane | ( | ushort | index,
|  | bool | enable )

## ◆ createHardwareOcclusionQuery()

HardwareOcclusionQuery * Ogre::D3D9RenderSystem::createHardwareOcclusionQuery | ( |  | ) |
| virtual

Create an object for performing hardware occlusion queries.

Implements Ogre::RenderSystem.

## ◆ getHorizontalTexelOffset()

Real Ogre::D3D9RenderSystem::getHorizontalTexelOffset | ( | void |  | ) |
| virtual

Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this rendersystem.

Since rendersystems sometimes disagree on the origin of a texel, mapping from texels to pixels can sometimes be problematic to implement generically. This method allows you to retrieve the offset required to map the origin of a texel to the origin of a pixel in the horizontal direction.

Note
  only non-zero with D3D9

Reimplemented from Ogre::RenderSystem.

## ◆ getVerticalTexelOffset()

Real Ogre::D3D9RenderSystem::getVerticalTexelOffset | ( | void |  | ) |
| virtual

Returns the vertical texel offset value required for mapping texel origins to pixel origins in this rendersystem.

Since rendersystems sometimes disagree on the origin of a texel, mapping from texels to pixels can sometimes be problematic to implement generically. This method allows you to retrieve the offset required to map the origin of a texel to the origin of a pixel in the vertical direction.

Note
  only non-zero with D3D9

Reimplemented from Ogre::RenderSystem.

## ◆ getMinimumDepthInputValue()

Real Ogre::D3D9RenderSystem::getMinimumDepthInputValue | ( |  | ) |
| virtual

Gets the minimum (closest) depth value to be used when rendering using identity transforms.

When using identity transforms you can manually set the depth of a vertex; however the input values required differ per rendersystem. This method lets you retrieve the correct value.

See also
  Renderable::getUseIdentityView, Renderable::getUseIdentityProjection

Implements Ogre::RenderSystem.

## ◆ getMaximumDepthInputValue()

Real Ogre::D3D9RenderSystem::getMaximumDepthInputValue | ( |  | ) |
| virtual

Gets the maximum (farthest) depth value to be used when rendering using identity transforms.

When using identity transforms you can manually set the depth of a vertex; however the input values required differ per rendersystem. This method lets you retrieve the correct value.

See also
  Renderable::getUseIdentityView, Renderable::getUseIdentityProjection

Implements Ogre::RenderSystem.

## ◆ IsActiveDeviceLost()

bool Ogre::D3D9RenderSystem::IsActiveDeviceLost | ( |  | ) |

## ◆ isDirectX9Ex()

bool Ogre::D3D9RenderSystem::isDirectX9Ex | ( |  | ) |
| inlinestatic

Tells whether the system is initialized with DirectX 9Ex driver Read more in http://msdn.microsoft.com/en-us/library/windows/desktop/ee890072(v=vs.85).aspx.

## ◆ getResourceManager()

D3D9ResourceManager * Ogre::D3D9RenderSystem::getResourceManager | ( |  | ) |
| static

## ◆ getDeviceManager()

D3D9DeviceManager * Ogre::D3D9RenderSystem::getDeviceManager | ( |  | ) |
| static

References D3D9DeviceManager.

## ◆ getDirect3D9()

IDirect3D9 * Ogre::D3D9RenderSystem::getDirect3D9 | ( |  | ) |
| static

## ◆ getResourceCreationDeviceCount()

UINT Ogre::D3D9RenderSystem::getResourceCreationDeviceCount | ( |  | ) |
| static

## ◆ getResourceCreationDevice()

IDirect3DDevice9 * Ogre::D3D9RenderSystem::getResourceCreationDevice | ( | UINT | index | ) |
| static

## ◆ getActiveD3D9Device()

IDirect3DDevice9 * Ogre::D3D9RenderSystem::getActiveD3D9Device | ( |  | ) |
| static

## ◆ getActiveD3D9DeviceIfExists()

IDirect3DDevice9 * Ogre::D3D9RenderSystem::getActiveD3D9DeviceIfExists | ( |  | ) |
| static

## ◆ getAdapterNumber()

uint32 Ogre::D3D9RenderSystem::getAdapterNumber | ( |  | ) |

## ◆ _getDepthStencilFormatFor()

D3DFORMAT Ogre::D3D9RenderSystem::_getDepthStencilFormatFor | ( | D3DFORMAT | fmt | ) |

Check which depthStencil formats can be used with a certain pixel format, and return the best suited.

## ◆ _checkTextureFilteringSupported()

bool Ogre::D3D9RenderSystem::_checkTextureFilteringSupported | ( | TextureType | ttype,
|  | PixelFormat | format,
|  | int | usage )

Check whether or not filtering is supported for the precise texture format requested with the given usage options.

## ◆ determineFSAASettings()

void Ogre::D3D9RenderSystem::determineFSAASettings | ( | IDirect3DDevice9 * | d3d9Device,
|  | size_t | fsaa,
|  | const String & | fsaaHint,
|  | D3DFORMAT | d3dPixelFormat,
|  | bool | fullScreen,
|  | D3DMULTISAMPLE_TYPE * | outMultisampleType,
|  | DWORD * | outMultisampleQuality )

Take in some requested FSAA settings and output supported D3D settings.

## ◆ beginProfileEvent()

virtual void Ogre::D3D9RenderSystem::beginProfileEvent | ( | const String & | eventName | ) |
| virtual

This marks the beginning of an event for GPU profiling.

Implements Ogre::RenderSystem.

## ◆ endProfileEvent()

virtual void Ogre::D3D9RenderSystem::endProfileEvent | ( | void |  | ) |
| virtual

Ends the currently active GPU profiling event.

Implements Ogre::RenderSystem.

## ◆ markProfileEvent()

virtual void Ogre::D3D9RenderSystem::markProfileEvent | ( | const String & | eventName | ) |
| virtual

Marks an instantaneous event for graphics profilers.

This is equivalent to calling

See also
  beginProfileEvent and
  endProfileEvent back to back.

Implements Ogre::RenderSystem.

## ◆ fireDeviceEvent()

void Ogre::D3D9RenderSystem::fireDeviceEvent | ( | D3D9Device * | device,
|  | const String & | name )

Fires a device related event.

References D3D9Device.

## ◆ getMultiheadUse()

MultiheadUseType Ogre::D3D9RenderSystem::getMultiheadUse | ( |  | ) | const
| inline

Returns how multihead should be activated.

## ◆ setDrawBuffer()

virtual bool Ogre::D3D9RenderSystem::setDrawBuffer | ( | ColourBufferType | colourBuffer | ) |
| virtual

Sets the colour buffer that the render system will to draw.

If the render system implementation or configuration does not support a particular value, then false will be returned and the current colour buffer value will not be modified.

Parameters

  colourBuffer | Specifies the colour buffer that will be drawn into.

Reimplemented from Ogre::RenderSystem.

## ◆ createStereoDriver()

void Ogre::D3D9RenderSystem::createStereoDriver | ( | const NameValuePairList * | miscParams | ) |

Creates a bridge to the Direct3D stereo driver implementation.

References D3D9Device.

## ◆ _cleanupDepthBuffers() [3/3]

void Ogre::RenderSystem::_cleanupDepthBuffers | ( | bool | bCleanManualBuffers = true | ) |

Removes all depth buffers.

Should be called on device lost and shutdown

Advanced users can call this directly with bCleanManualBuffers=false to remove all depth buffers created for RTTs; when they think the pool has grown too big or they've used lots of depth buffers they don't need anymore, freeing GPU RAM.

The documentation for this class was generated from the following file:

- OgreD3D9RenderSystem.h